//DECLARATIONS

#ifndef HFILE_H
#define HFILE_H
#include <QtGui>

class MyWidget : public QWidget
{
    Q_OBJECT
    public:
        MyWidget (QWidget* parent = 0);

        QPixmap plot(QList<int>, QList<double>, int);
        QPixmap plot0(QList<int>, QList<double>, int);
        void getParameters();
        void getManhattan0();
        void getManhattan();

    public slots:
        void checkBox1Action();
        void checkBox2Action();
        void saveAndRemove();
        void Save();
        bool makeFile();
        void getFilename();
        void displayGlobal();
        void displayLocal();
        void reloadPhoto();
        void reloadPhoto0();
        void showRemaining();
        void removeSelection();

     signals:
        void getSize();
           
    protected:
        void mouseMoveEvent(QMouseEvent *event);
        void mousePressEvent(QMouseEvent *event);
        void mouseReleaseEvent(QMouseEvent *event);
        void copyAndPaste();
        void selectChromosome();
        
    private:
        QVBoxLayout* mainLayout;
        QHBoxLayout* graphicsLayout;
        QVBoxLayout* picturevertLayout;
        QHBoxLayout* pictureLayout;
        QVBoxLayout* controlsLayout;
        QHBoxLayout* buttonLayout;
        QHBoxLayout* buttonLayout2;
        QHBoxLayout* clusterLayout;
        QHBoxLayout* maincontrolLayout;

        QLineEdit* startEdit;
        QLineEdit* endEdit;

        QLabel* pixmapLabel;
        QLabel* textLabel;
        QLabel* fileLabel;
        
        QPushButton* remainingButton;
        QPushButton* newFileButton;
        QPushButton* globalFileButton;
        QPushButton* fileButton;
        QPushButton* exitButton;
        QPushButton* removeButton;
        QPushButton* removeButton2;
        QCheckBox* checkBox1;
        QCheckBox* checkBox2;

        QRubberBand* rubberBand;
        QPoint origin;  
        QPoint myPoint;
        QStringList list;
  
        QString filenametext;
        QPixmap pm_orig;
        QImage original_image;
        QRect ekraan;
        QDir lastDir;
        QPixmap globalmap;
};
      
#endif
