#include <QApplication>
#include <QtPlugin>
#include <QtGui>
#include "hfile.h"
#include "draw.cpp"
#include "rubberband.cpp"
#include "cluster.cpp"

 ////////////////////////////////////////////////////////////////////////////////////////
MyWidget::MyWidget(QWidget* parent): QWidget(parent)
{    

        
    mainLayout = new QVBoxLayout;
      graphicsLayout = new QHBoxLayout;  
         pictureLayout = new QHBoxLayout;
          picturevertLayout = new QVBoxLayout;

      controlsLayout = new QVBoxLayout;
         buttonLayout = new QHBoxLayout;
         buttonLayout2 = new QHBoxLayout;
      clusterLayout = new QHBoxLayout; 
         maincontrolLayout = new QHBoxLayout;
        
    pixmapLabel = new QLabel;          
          QPalette Pal2(pixmapLabel->palette()); Pal2.setColor(QPalette::Window, QColor::fromRgb(150,150,150));
          pixmapLabel->setAutoFillBackground(true); 
          pixmapLabel->setPalette(Pal2);

    fileLabel = new QLabel;
          QPalette Pal(fileLabel->palette()); Pal.setColor(QPalette::Window, Qt::gray);
          fileLabel->setAutoFillBackground(true); 
          fileLabel->setPalette(Pal); 
    
    textLabel = new QLabel; textLabel->setText("HINT: Draw a box anywhere in/around a chromosome to select the chromsome");

           checkBox1 = new QCheckBox;
           checkBox1->setCheckState(Qt::Unchecked);
         
           checkBox2 = new QCheckBox;
           checkBox2->setCheckState(Qt::Checked);


      startEdit = new QLineEdit;
      endEdit = new QLineEdit;

 
    newFileButton = new QPushButton("&New File");
             newFileButton->setStyleSheet(
                                      "background:lightblue; color: black; font-size:12px;"
                                      "font-weight:bold;"
                                       );                               

    globalFileButton = new QPushButton("&Global");
             globalFileButton->setStyleSheet(
                                      "background:pink; color: black; font-size:12px;"
                                      "font-weight:bold;"
                                       );     


   remainingButton = new QPushButton("&Unzoom");
             remainingButton->setStyleSheet(
                                      "background:green; color: black; font-size:12px;"
                                      "font-weight:bold;"
                                       );
             
    removeButton = new QPushButton("&Remove Selection");
           removeButton->setStyleSheet(
                                      "background:green; color:black; font-size:12px;"
                                      "font-weight:bold;"
                                       ); 

        
    fileButton = new QPushButton("&Save");
             fileButton->setStyleSheet(
                                      "background:orange; color: black; font-size:12px;"
                                      "font-weight:bold;"
                                       );

    removeButton2 = new QPushButton("Save &and Remove");
           removeButton2->setStyleSheet(
                                      "background:orange; color:black; font-size:12px;"
                                      "font-weight:bold;"
                                       );  

    exitButton = new QPushButton("&Exit");
             exitButton->setStyleSheet(
                                      "background:darkred; color:white; font-size:12px;"
                                      "font-weight:bold;"
                                       );
 
                                       


    rubberBand = new QRubberBand(QRubberBand::Rectangle, pixmapLabel);  

    QLabel *vDivider1 = new QLabel; vDivider1->setFrameStyle(QFrame::HLine | QFrame::Sunken); vDivider1->setLineWidth(2);
    vDivider1->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding); 

    QLabel *vDivider2 = new QLabel; vDivider2->setFrameStyle(QFrame::HLine | QFrame::Sunken); vDivider2->setLineWidth(2);
    vDivider2->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding); 

    connect(newFileButton, SIGNAL(clicked()), this, SLOT(getFilename()));
    connect(globalFileButton, SIGNAL(clicked()), this, SLOT(displayGlobal()));
    connect(remainingButton, SIGNAL(clicked()), this, SLOT(showRemaining()));
    connect(removeButton, SIGNAL(clicked()), this, SLOT(removeSelection()));
    connect(removeButton2, SIGNAL(clicked()), this, SLOT(saveAndRemove()));
    connect(fileButton, SIGNAL(clicked()), this, SLOT(Save()));
    connect(exitButton, SIGNAL(clicked()), qApp, SLOT(quit()));
    connect(checkBox1, SIGNAL(stateChanged(int)), this, SLOT(checkBox1Action()));
    connect(checkBox2, SIGNAL(stateChanged(int)), this, SLOT(checkBox2Action()));
    connect(this, SIGNAL(getSize()), this, SLOT(reSize()));

    
    mainLayout->addLayout(graphicsLayout);
      graphicsLayout->addLayout(pictureLayout);
          graphicsLayout->addLayout(picturevertLayout);      

          
    mainLayout->addLayout(controlsLayout); 
      controlsLayout->addLayout(buttonLayout);
      controlsLayout->addLayout(buttonLayout2);
      
    mainLayout->addLayout(clusterLayout); 
    clusterLayout->addLayout(maincontrolLayout);
    
    
    picturevertLayout->addWidget(pixmapLabel);

    buttonLayout2->addWidget(fileLabel);
    buttonLayout2->addWidget(vDivider1);

    buttonLayout2->addWidget(checkBox1);
    buttonLayout2->addWidget(textLabel);
    buttonLayout2->addWidget(checkBox2); 
    buttonLayout2->addWidget(vDivider2);

    buttonLayout2->addWidget(startEdit);
    buttonLayout2->addWidget(endEdit);

    maincontrolLayout->addWidget(newFileButton);
    maincontrolLayout->addWidget(globalFileButton);
    maincontrolLayout->addWidget(remainingButton);
    maincontrolLayout->addWidget(removeButton);
    maincontrolLayout->addWidget(fileButton);
    maincontrolLayout->addWidget(removeButton2);
    maincontrolLayout->addWidget(exitButton);
    
    setLayout(mainLayout);
    
    
     ekraan = qApp->desktop()->screenGeometry();
     lastDir = QDir::current();
     checkBox2Action();
     getFilename();
}

/////////////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[])//main function
{
    QApplication application(argc, argv);
     
    MyWidget window;
    window.setWindowTitle("CROPPER 0.1 by Tom Haller  (tom@toomashaller.com)");
    window.move(5,5);
        
    window.show();
    return application.exec();
}
